﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;
using System.IO;
using UnityEngine.SceneManagement;

public class Personagem : MonoBehaviour {
	float Vx; 	//velocidade em x
	float Vy;	//velocidade em y
	float VelocidadeHorizontal;
	float VelocidadeVertical;
	float VelocidadePular;
	float DirecaoHorizontal; //variavel que armazena a direção: para esquerda, para a direita ou parado
	float DirecaoVertical; //variavel que armazena a direção: para cima, para a baixo ou parado
	Rigidbody2D CorpoRigido; //corpo rígido do elemento onde o script foi inserido.
	BoxCollider2D Colisor; // colisor do elemento onde o script foi inserido.
	bool PodeJogar =true;
	public Text lblPontosPainel;
	public Text lblPontos;
	public InputField CaixaTexto;
	public Button btnSalvarPontos;
	public GameObject Painel;
	int Pontos;

	//"void Start ()" Executado na inicialização do jogo utilizado para iniciar variáveis e parametros 
	void Start () {
		Vx = 0;		//inicia a velocidade em x
		Vy = 0;		//inicia a velocidade em y
		DirecaoVertical = 0;		// inicia a direção vertical("andar para cima e para baixo")
		DirecaoHorizontal = 0;		// inicia a direção horizontal(andar)
		VelocidadeHorizontal = 5;	//incia a velocidade de andar na horizontal(direita e esquerda)
		VelocidadeVertical = 5;		//inicia a velocidade de andar na vertical	(para cima e para baixo)
		VelocidadePular	= 5;		//inicia a velocidade de pular
		CorpoRigido = GetComponent<Rigidbody2D> ();		//recupera o corpo rigido inserido no elemento que possui o script(corpo rígido do personagem)
		Colisor = GetComponent<BoxCollider2D> (); 	//recupera o colisor inserido no elemento que possui o script(colisor do personagem)	
		CorpoRigido.freezeRotation = true;				//impede que rotacione no eixo.
		//inicia a escala de gravidade com 1 - caso utilize MovimentoVertical()  ao invés Pular() gravityScale = 1 deve ser igual 0
		CorpoRigido.gravityScale = 1;	
		btnSalvarPontos.onClick.AddListener(clickSalvarPontos);
	
		Pontos = 0;
	}

	void clickSalvarPontos(){
		string nome = CaixaTexto.text;
		string textoSalvar = nome + "\t" + Pontos.ToString () + "\n";
		string nomeAquivo = "pontos.txt";
		File.AppendAllText(nomeAquivo, textoSalvar);

		// Reading the text from the madrid.txt file
		string todosPontos = File.ReadAllText(nomeAquivo);
		print (todosPontos);

		SceneManager.LoadScene("fase02");

	}
	void AtualizarPontos(){

		lblPontosPainel.text = Pontos.ToString ();
		lblPontos.text = Pontos.ToString ();

	}
	//"void Update ()" Executado uma vez por frame. 
	void Update () {
		if (PodeJogar == true) {
			MovimentoHorizontal ();
			Pular ();
			AtualizarPontos ();
		}
		//MovimentoVertical ();
	}
	void Pular(){
		//verdadeiro(true) se o botão de Jump foi pressionado caso contrário igual a false
		bool apertou = Input.GetButtonDown ("Jump");

		//verdadeiro(true) se o personagem estiver tocando outro collider
		bool tocou = Colisor.IsTouchingLayers ();

		if (apertou == true && tocou == true) {
			// esse bloco só é executado se for apertado o botão de Jump
			// e se o personagem estiver tocando em alguma coisa com colidder
			Vx = CorpoRigido.velocity.x;
			Vy = VelocidadePular;
			Vector2 pulo = new Vector2 (Vx, Vy);
			CorpoRigido.velocity = pulo;
		}
	}

	void MovimentoHorizontal(){
		//DirecaoHorizontal Recebe até 1 quando precionado o botão para direita e até -1 para esquerda. Quando parado Recebe 0.
		DirecaoHorizontal = Input.GetAxis ("Horizontal");
		// Gera uma nova velocidade em x
		Vx = VelocidadeHorizontal * DirecaoHorizontal;
		//Recupera a velocidade em y que o personagem já possui
		Vy = CorpoRigido.velocity.y;
		//Cria um vetor de velocidade com os valores da velocidade em x e da velocidade em y (vx e vy)
		Vector2 andar = new Vector2 (Vx, Vy);
		// O vetor de velocidade é adicionado a velocidade do corpo rígido do personagem
		CorpoRigido.velocity = andar;
	}

	void MovimentoVertical(){
		//DirecaoVertical Recebe até 1 quando precionado o botão para cima e até -1 para baixo. Quando parado Recebe 0.
		DirecaoVertical = Input.GetAxis ("Vertical");
		Vx = CorpoRigido.velocity.x; //Recupera a velocidade em x que o personagem já possui em seu corpo rígido
		// Gera uma nova velocidade em y
		Vy = VelocidadeVertical*DirecaoVertical;

		Vector2 vetorMovimento = new Vector2 (Vx, Vy);  //Cria um vetor de velocidade com os valores da velocidade em x e da velocidade em y (vx e vy)
		CorpoRigido.velocity = vetorMovimento;			// O vetor de velocidade é adicionado a velocidade do corpo rígido do personagem
	}

	//(Collision2D objetoTocado) é executado sempre que um colisor toca em outro colisor
	//a variável objetoTocado possui dados do objeto tocado.
	void OnCollisionEnter2D(Collision2D objetoTocado){
		// a variável tagTocada é igual a tag do elemento que o personagem tocou
		//por que personagem? 
		//Porque o programa está dentro do personagem! :)
		string tagTocada = objetoTocado.gameObject.tag; 

		// entra no if quando  o personagem toca em um objeto configurado com a tag "tipo1" e  a velocidade for menor que 10
		if (tagTocada == "contarPontos" ) {
			Pontos++;
			print (Pontos);
			Destroy (objetoTocado.gameObject);

		}
		if (tagTocada == "inimigo") {
			Painel.SetActive (true);
			PodeJogar = false;

		}
		// entra no if quando  o personagem toca em um objeto configurado com a tag "tipo2" e  a velocidade for maior ou igual a 2

	}





}

